#include "KlappenAblauf.h"



KlappenAblauf::~KlappenAblauf()
{
}


void KlappenAblauf::setOpen(bool open)
{
  openSpeicher = open;


}

void  KlappenAblauf::setOpen(bool open , int id)
{ 
  KlappenAblauf *zeiger;
  zeiger = (KlappenAblauf *) searchIdElement(id);
  if(zeiger)
    return zeiger->setOpen(open);
}

void KlappenAblauf::memberSetup(){
  
  AnalogDigital::memberSetup();
  openSpeicher = false;
  fsmInit();
}

void KlappenAblauf::memberLoop(){
  AnalogDigital::memberLoop();
  openSpeicherAbfrage();
  fsmStep();
}

void KlappenAblauf::fsmInit(){
  aktuellerState = INIT;
    


}

void KlappenAblauf::openSpeicherAbfrage(){
  if(openSpeicher){
    if(aktuellerState == WARTE_GESCHLOSSEN){
      aktuellerState = START_AUF;
    }
  }else{
    if(aktuellerState == WARTE_OFFEN){
        aktuellerState = START_ZU;
    }
  }

}



void KlappenAblauf::fsmStep(){

  switch (aktuellerState)
  {
  case INIT:
    aktuellerState = START_AUF;
    setOpen(false);
    break;

  case WARTE_OFFEN:
  case WARTE_GESCHLOSSEN:
    break;

  case START_AUF:
    setMotorAktion(1);
    timer = 5000;
    aktuellerState = FAEHRT_AUF;
    break;

  case START_ZU:
    setMotorAktion(-1);
    timer = 5000;
    aktuellerState = FAEHRT_ZU;
    break;

  case FAEHRT_AUF:
    timer -= getDeltamsec();
    if(timer <= 0){
      setMotorAktion(0);
      aktuellerState = WARTE_OFFEN;
    }
    break;

  case FAEHRT_ZU:
    timer -= getDeltamsec();
    if(timer <= 0){
      setMotorAktion(0);
      aktuellerState = WARTE_GESCHLOSSEN;
    }
    break;

  default:
    aktuellerState = INIT;
    break;
  }

}
