#include <Arduino.h>

#include "pins.h"
#include "KlappenSteuerung.h"


void Ablauf();
void AblaufSekunde();

KlappenSteuerung klappe1 (M1A , M1B , M1SENSE , 5  );
KlappenSteuerung klappe2 (M2A , M2B , M2SENSE , 2  );
KlappenSteuerung klappe3 (M3A , M3B , M3SENSE , 23 );
//KlappenSteuerung klappe4 (M4A , M4B , M4SENSE , 1  );



void setup() {
  // put your setup code here, to run once:
  KlappenSteuerung::setupStatic();
  KlappenSteuerung::setMotorPwmPin(TIMER1_PWM_PIN);
  KlappenSteuerung::setup();
  pinMode(LED_BUILTIN , OUTPUT);
  pinMode(TASTER_AUF , INPUT_PULLUP);
  pinMode(TASTER_ZU , INPUT_PULLUP);
}

void loop() {
  // put your main code here, to run repeatedly:
  KlappenSteuerung::loop();
  Ablauf();
}

void Ablauf(){
  if(!digitalRead(TASTER_AUF))
    KlappenSteuerung::setOpen(true , 5);

  if(!digitalRead(TASTER_ZU))
    KlappenSteuerung::setOpen(false , 5);
}

