
#ifndef KLAPPENABLAUF_H
#define KLAPPENABLAUF_H

#include "statusKlappen.h"
#include "analogDigital.h"

/**
  * class KlappenAblauf
  * 
  */

class KlappenAblauf : public AnalogDigital
{
public:
  // Constructors/Destructors
  //  


  /**
   * Empty Constructor
   */
  //KlappenAblauf();

  /**
   * Empty Destructor
   */
  virtual ~KlappenAblauf();

  // Static Public attributes
  //  

  // Public attributes
  //

   /**
   * @param  open
   */
  void setOpen(bool open);
  static void setOpen(bool open , int id);

protected:

  virtual void memberSetup();
  virtual void memberLoop();

  // Static Protected attributes
  //  

  // Protected attributes
  //

private:

  int16_t timer;

  bool openSpeicher;
  void openSpeicherAbfrage();
  typedef enum fsmStatesEnum{
    INIT,

    WARTE_OFFEN,
    START_ZU,
    FAEHRT_ZU,

    WARTE_GESCHLOSSEN,
    START_AUF,
    FAEHRT_AUF,

  }fsmStates;
  
  fsmStates aktuellerState;

  void fsmInit();
  void fsmStep();


};

#endif // KLAPPENABLAUF_H
